;==============================================================================
;
; MSX1 X^[tH[X Ge_ŉ
;
;==============================================================================
org				#ba0c
prog_end	equ	#bc00


macro	PUBLBL, _name
public	_name
_name:
endm
macro	PUBDEF, _name, _value
public	_name
_name	equ	_value
endm

; #FFI[̏o[`荞݋֎~ɂ
val_eb_in_rom_06A5		equ	#c3
val_cd53_in_rom_06A6	equ	put_str_core


;================================================================
;	_Ńp^[
;================================================================
PUBLBL	bullet_color_tbl
		db	12,12,1,1,12,12,15,1,12,12,1,1,12,12,15,1


PUBLBL	bg_color_tbl
		db	0,6,0,1,4,14,15,1,2,4,15,6,11,3




;================================================================
;	oN؂ւ
;================================================================
PUBLBL	enter_bank_4
		push	af
		ld		a,4
		ld		(#6000),a
		pop		af
		ret

PUBLBL	exit_to_bank_0
		push	af
		xor		a
		ld		(#6000),a
		pop		af
		ret


;================================================================
;	VRAMANZX
;================================================================
MACRO	mSetVramAdr, regH, regL
		ld		a,(#0007)
		ld		c,a
		inc		c

		ld		a,regH
		rlca
		rlca
		and		#3
		out		(c),a
		ld		a,#8e
		out		(c),a
		out		(c),regL
		ld		a,regH
		and		#3f
		or		#40
		out		(c),a
		dec		c
		ret
ENDM

MACRO	mSetRdVramAdr, regH, regL
		ld		a,(#0007)
		ld		c,a
		inc		c

		ld		a,regH
		rlca
		rlca
		and		#3
		out		(c),a
		ld		a,#8e
		out		(c),a
		out		(c),regL
		ld		a,regH
		and		#3f
		out		(c),a
		dec		c
		ret
ENDM

PUBLBL	set_vram_adr_hl
		mSetVramAdr		h, l

PUBLBL	set_vram_adr_de
		mSetVramAdr		d, e

PUBLBL	set_read_vram_adr_hl
		mSetRdVramAdr	h, l

PUBLBL	set_read_vram_adr_de
		mSetRdVramAdr	d, e


PUBLBL	di_004d
		push	af
		call	set_vram_adr_hl
		pop		af
		out		(c),a
		ret

PUBLBL	di_005c
		push	bc
		call	set_vram_adr_de
		pop		de

		ld		b,e
		dec		de
		inc		d
	_lp_di_005c:
		otir
		dec		d
		jp		nz,_lp_di_005c
		ret

PUBLBL	di_0056
		push	hl
		push	bc
		push	af
		call	set_vram_adr_hl
		pop		af
		pop		hl

		ld		b,l
		dec		hl
		inc		h
	_lp_di_0056:
		out		(c),a
		djnz	_lp_di_0056
		dec		h
		jp		nz,_lp_di_0056

		pop		hl
		ret


;================================================================
; VRAMԃRs[	src:hl dst:de len:bc
;================================================================
PUBLBL	vcopy
		inc		b
		dec		b
		jr		z,_low
	_lpH:
		push	bc
		push	hl
		ld		b,0
		call	vcopy8
		pop		hl
		inc		h
		inc		d
		pop		bc
		djnz	_lpH
	_low:
		inc		c
		dec		c
		ret		z
		ld		b,c
PUBLBL	vcopy8
		push	bc
		call	set_read_vram_adr_hl
		ld		a,(#0006)
		ld		c,a
		ld		hl,#ed00
		inir

		pop		bc
		call	set_vram_adr_de
		ld		hl,#ed00
		otir
		ret


;================================================================
;	hl+=a
;================================================================
PUBLBL	add_hl_a
		add		a,l
		ld		l,a
		ret		nc
		inc		h
		ret

;================================================================
;	de+=a
;================================================================
PUBLBL	add_de_a
		add		a,e
		ld		e,a
		ret		nc
		inc		d
		ret


;==============================================================================
;	#FFI[̏o	hl:src	de:vram ofs
;==============================================================================
PUBLBL	put_str_core
		ex		de,hl
		di
		call	set_vram_adr_hl
	_lp:
		ld		a,(de)
		cp		#ff
		jr		z,_end
		add		a,#80
		cp		#a0
		jr		nz,_out
		add		a,#20
	_out:
		out		(c),a
		inc		de
		jp		_lp
	_end:
		ei
		ret

PUBLBL	put_str
		push	hl
		push	de
		push	bc
		ex		de,hl
		ld		bc,(#f3c7)	; name table
		add		hl,bc
		call	put_str_core+1
		pop		bc
		pop		de
		pop		hl
		ret




;================================================================
;	VRAMv
;================================================================
PUBLBL	write_vram_req_init
		ld		hl,#ee3a
		ld		(#ee36),hl
		ld		(hl),0
		inc		l
		ld		(hl),0
		ret


;================================================================
;	VRAMv
;================================================================
PUBLBL	write_sprite_req
		push	bc
		ld		bc,(#f3cf) ; sprite generator addr
		add		hl,bc
		pop		bc
PUBLBL	write_vram_req
		push	af
		di
		ld		(#ee38),sp
		ld		sp,(#ee36)
		pop		af
		pop		af
		pop		af
		ld		(#ee36),sp
		push	bc
		push	de
		push	hl
		ld		sp,(#ee38)
		ei
		pop		af
		ret


filler:
	ds	prog_end-filler
