;==============================================================================
;
; MSX1 X^[tH[X Ge_ŉ
;
;==============================================================================
macro	PUBLBL, _name
public	_name
_name:
endm
macro	PUBDEF, _name, _value
public	_name
_name	equ	_value
endm




;================================================================
;	L[
;================================================================
PUBLBL	get_key
		call	#009c
		ld		a,0
		ret		z
		call	#009f
		or		a
		ret

;================================================================
;	wiFXV
;================================================================
bgc_base	equ		#94d4
PUBLBL	update_bg_color_all
		call	update_bg_color
		jp		update_bg_color_postproc

PUBLBL	update_bg_color
		di

		ld		hl,bgc_base+8*top_of_rocks
		ld		de,#2000+8*top_of_rocks
		ld		bc,8*num_of_rocks
		exx
		ld		hl,bg_color_tbl
		ld		de,#ee20+colors_of_rocks-1
		ld		bc,colors_of_rocks
		exx
		call	update_bg_color_sub

		ld		hl,bgc_base+8*top_of_walls
		ld		de,#2000+8*top_of_walls
		ld		bc,8*num_of_walls
		exx
		ld		hl,bg_color_tbl+colors_of_rocks
		ld		de,#ee20+colors_of_rocks+colors_of_walls-1
		ld		bc,colors_of_walls
		exx
		call	update_bg_color_sub

		ld		hl,bgc_base+8*top_of_panes
		ld		de,#2000+8*top_of_panes
		ld		bc,8*num_of_panes
		exx
		ld		hl,bg_color_tbl+colors_of_rocks+colors_of_walls
		ld		de,#ee20+colors_of_rocks+colors_of_walls+colors_of_panes-1
		ld		bc,colors_of_panes
		exx
		call	update_bg_color_sub

		ei
		ret

update_bg_color_sub:
		push	bc
		call	set_vram_adr_de
		pop		de

		ld		b,e
		dec		de
		inc		d
		ld		e,b
	_lpL:
		ld		a,(hl)

		exx
		call	update_bg_color_sub_sub
		ld		b,a
		exx

		ld		a,(hl)
		rra
		rra
		rra
		rra

		exx
		call	update_bg_color_sub_sub
		rla
		rla
		rla
		rla
		and		#f0
		or		b
		exx

		out		(c),a
		inc		hl
		dec		e
		jr		nz,_lpL
		dec		d
		jr		nz,_lpL

		ret

update_bg_color_sub_sub:
		push	hl
		push	de
		push	bc
		and		#f
		ld		b,0
		cpir
		jr		nz,_ret
		ex		de,hl
		xor		a
		sbc		hl,bc
		ld		a,(hl)
	_ret:
		pop		bc
		pop		de
		pop		hl
		ret


; PCGJ[e[üiڂSiɃRs[
PUBLBL	update_bg_color_postproc
		di
		ld		hl,#2000
		ld		de,#2800
		ld		bc,#0800
		call	vcopy

		ld		hl,#2000
		ld		de,#3000
		ld		bc,#0800
		call	vcopy

		ld		hl,#2000
		ld		de,#3800
		ld		bc,#0800
		call	vcopy
		ei
		ret


;================================================================
;	ҏW[h؂ւ
;================================================================
editor_setup:
		di
		; ʃNA
		xor		a
		ld		hl,#4020
		ld		bc,#03e0
		call	di_0056
		xor		a
		ld		hl,#4800
		ld		bc,#0400
		call	di_0056

		; sprite display stop
		ld		hl,#e680
		ld		a,(hl)
		ld		(#ee13),a
		ld		a,(#ee31)
		neg
		add		a,#d0
		ld		(hl),a

		ei
		ret


editor_close:
		call	dumb_loop

		; sprite display resume
		ld		a,(#ee13)
		ld		(#e680),a
		; resume display
		ld		a,(#ee32)
		inc		a
		ld		(#ee32),a

		ld		a,#ff
		ret


dumb_loop:
		ld		bc,0
	_lp:
		cpi
		cpd
		ret		po
		jr		_lp


;================================================================
;	GeFҏW[h
;================================================================
PUBLBL	enemy_bullet_editor
		call	editor_setup

		jr		_key_off_wait

	_main_loop:
		call	get_key
		jr		z,_main_loop
		cp		#1b
		jp		z, editor_close

		ld		hl,#ee10
		cp		#1e
		jr		nz,_not_up
		ld		a,(hl)
		dec		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_up:
		cp		#1f
		jr		nz,_not_down
		ld		a,(hl)
		inc		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_down:
		cp		#1c
		jr		nz,_not_right
		ld		l,(hl)
		ld		a,(hl)
		inc		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_right:
		cp		#1d
		jr		nz,_not_left
		ld		l,(hl)
		ld		a,(hl)
		dec		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_left:
		cp		'0'
		jr		c,_not_0_9
		cp		'9'+1
		jr		nc,_not_0_9
		sub		'0'
		jr		_0_9_A_Z
	_not_0_9:
		cp		'a'
		jr		c,_main_loop
		cp		'f'+1
		jr		nc,_main_loop
		sub		'a'-10
		jr		_0_9_A_Z
	_not_a_z:
		cp		'A'
		jr		c,_main_loop
		cp		'F'+1
		jr		nc,_main_loop
		sub		'A'-10
	_0_9_A_Z:
		ld		l,(hl)
		ld		(hl),a
	_key_off_wait:
		call	update_enemy_bullet_editor
		call	get_key
		jr		nz,_key_off_wait
		jr		_main_loop




;==============================================================================
;	GeFҏW[h\
;==============================================================================
update_enemy_bullet_editor:
		ld		hl,tx_header
		ld		de,#0044
		call	put_str

		ld		de,#0084
		ld		b,#10
	_loop:
		ld		a,#10
		sub		b
		ld		c,a

		ld		a,(#ee10)
		cp		c
		ld		hl,tx_cursor
		jr		z,_put_cursor
		ld		hl,tx_space
	_put_cursor:
		call	put_str

		inc		de
		inc		de

		call	put_number
		
		ld		a,#0a
		call	add_de_a

		ld		h,#ee
		ld		l,c
		ld		a,(hl)
		call	put_color_name

		ld		a,#20-2-#a
		call	add_de_a
		djnz	_loop

		ret




;================================================================
;	wiFҏW[h
;================================================================
PUBLBL	bg_color_editor
		call	editor_setup

		di

		ld		hl,(#f3c7)	; name table
		ld		a,l
		add		a,#40
		ld		l,a
		call	set_vram_adr_hl
		xor		a
		ld		b,#80
	_list_pcg:
		out		(c),a
		inc		a
		djnz	_list_pcg

		ld		hl,tx_bge_lb0
		ld		de,#00e6
		ld		b,colors_of_bg
	_list_label:
		call	put_str
		ld		a,#6
		call	add_hl_a
		ld		a,#20
		call	add_de_a
		djnz	_list_label

		ei

		jr		_key_off_wait

	_main_loop:
		call	get_key
		jr		z,_main_loop
		cp		#1b
		jr		z,_exit

		ld		hl,#ee11

		cp		#1e
		jr		nz,_not_up
		ld		a,(hl)
		or		a
		jr		nz,_not_top
		ld		a,colors_of_bg
	_not_top:
		dec		a
		ld		(hl),a
		jr		_key_off_wait
	_not_up:
		cp		#1f
		jr		nz,_not_down
		ld		a,(hl)
		inc		a
		cp		colors_of_bg
		jr		nz,_not_btm
		xor		a
	_not_btm:
		ld		(hl),a
		jr		_key_off_wait
	_not_down:
		cp		#1c
		jr		nz,_not_right
		call	get_current_bg_color
		inc		a
		jr		_update
	_not_right:
		cp		#1d
		jr		nz,_not_left
		call	get_current_bg_color
		dec		a
		jr		_update
	_not_left:
		cp		'0'
		jr		c,_not_0_9
		cp		'9'+1
		jr		nc,_not_0_9
		sub		'0'
		jr		_0_9_A_Z
	_not_0_9:
		cp		'a'
		jr		c,_main_loop
		cp		'f'+1
		jr		nc,_main_loop
		sub		'a'-10
		jr		_0_9_A_Z
	_not_a_z:
		cp		'A'
		jr		c,_main_loop
		cp		'F'+1
		jr		nc,_main_loop
		sub		'A'-10
	_0_9_A_Z:
		push	af
		call	get_current_bg_color
		pop		af
	_update:
		and		#f
		ld		(hl),a
		call	update_bg_color
	_key_off_wait:
		call	update_bg_color_editor
		call	get_key
		jr		nz,_key_off_wait
		jr		_main_loop

	_exit:
		call	update_bg_color_postproc
		jp		editor_close


get_current_bg_color:
		ld		hl,#ee11
		ld		a,(hl)
		add		a,#20
		ld		l,a
		ld		a,(hl)
		ret

update_bg_color_editor:
		ld		de,#00e4
		ld		bc,colors_of_bg*256

		di
	_loop:
		ld		a,(#ee11)
		cp		c
		ld		hl,tx_cursor
		jr		z,_put_cursor
		ld		hl,tx_space
	_put_cursor:
		call	put_str

		ld		a,#0a
		call	add_de_a

		ld		a,c
		ld		hl,#ee20
		call	add_hl_a
		ld		a,(hl)
		call	put_color_name

		ld		a,#20-#0a
		call	add_de_a
		inc		c
		djnz	_loop

		ei
		ret



;==============================================================================
;	F̏o	a:color code de:vram ofs
;==============================================================================
put_color_name:
		push	hl
		ld		l,a
		add		a,a
		add		a,a
		add		a,a
		add		a,l
		ld		hl,tx_c0
		call	add_hl_a
		call	put_str
		pop		hl
		ret

;==============================================================================
;	l̏o	a:0-9a-f de:vram ofs
;==============================================================================
put_number:
		push	bc
		ld		a,c
		add		a,a
		add		a,c
		ld		hl,tx_0
		call	add_hl_a
		call	put_str
		pop		bc
		ret




;================================================================
;	e[vǂݍ
;================================================================
PUBLBL	tape_load
		call	editor_setup

		ld		hl,tx_tape_r
		ld		de,#0146
		call	put_str

		call	#00e1
		jr		c,_err_o

		ld		hl,#ee00
		ld		b,#10
		call	tape_load_sub
		jr		c,_err_r

		ld		hl,#ee20
		ld		b,#10
		call	tape_load_sub
		jr		c,_err_r

		ld		hl,#e3d5
		ld		b,#3
		call	tape_load_sub
		jr		c,_err_r

	_end:
		call	#00e7
		call	update_bg_color_all
		jp		editor_close

	_err_o:
		ld		hl,tx_tape_eo
		jr		_err
	_err_r:
		ld		hl,tx_tape_er
	_err:
		ld		de,#0168
		call	put_str
		jp		_end


tape_load_sub:
	_lp:
		exx
		call	#00e4
		ret		c
		exx
		ld		(hl),a
		inc		l
		djnz	_lp
		xor		a
		ret


;================================================================
;	e[vۑ
;================================================================
PUBLBL	tape_save
		call	editor_setup

		ld		hl,tx_tape_w
		ld		de,#0146
		call	put_str

		call	#00ea
		jr		c,_err_o

		ld		hl,#ee00
		ld		b,#10
		call	tape_save_sub
		jr		c,_err_w

		ld		hl,#ee20
		ld		b,#10
		call	tape_save_sub
		jr		c,_err_w

		ld		hl,#e3d5
		ld		b,#3
		call	tape_save_sub
		jr		c,_err_w

	_end:
		call	#00f0
		jp		editor_close

	_err_o:
		ld		hl,tx_tape_eo
		jr		_err
	_err_w:
		ld		hl,tx_tape_ew
	_err:
		ld		de,#0168
		call	put_str
		jp		_end


tape_save_sub:
	_lp:
		ld		a,(hl)
		exx
		call	#00ed
		ret		c
		exx
		inc		l
		djnz	_lp
		xor		a
		ret




;==============================================================================
;	
;==============================================================================
tx_header:	db	"FRAME@ENEMY\\BULLET\\COLOR",#FF

tx_space:	db	"@",#FF
tx_cursor:	db	"?",#FF

tx_0:	db	"00",#FF
tx_1:	db	"01",#FF
tx_2:	db	"02",#FF
tx_3:	db	"03",#FF
tx_4:	db	"04",#FF
tx_5:	db	"05",#FF
tx_6:	db	"06",#FF
tx_7:	db	"07",#FF
tx_8:	db	"08",#FF
tx_9:	db	"09",#FF
tx_A:	db	"10",#FF
tx_B:	db	"11",#FF
tx_C:	db	"12",#FF
tx_D:	db	"13",#FF
tx_E:	db	"14",#FF
tx_F:	db	"15",#FF

tx_c0:	db	"0\\BLACK@",#FF
tx_c1:	db	"1\\BLACK@",#FF
tx_c2:	db	"2\\GREEN@",#FF
tx_c3:	db	"3\\GREEN@",#FF
tx_c4:	db	"4\\BLUE@@",#FF
tx_c5:	db	"5\\BLUE@@",#FF
tx_c6:	db	"6\\RED@@@",#FF
tx_c7:	db	"7\\CYAN@@",#FF
tx_c8:	db	"8\\RED@@@",#FF
tx_c9:	db	"9\\RED@@@",#FF
tx_cA:	db	"A\\YELLOW",#FF
tx_cB:	db	"B\\YELLOW",#FF
tx_cC:	db	"C\\GREEN@",#FF
tx_cD:	db	"D\\PURPLE",#FF
tx_cE:	db	"E\\GRAY@@",#FF
tx_cF:	db	"F\\WHITE@",#FF

PUBDEF	colors_of_rocks	,2
PUBDEF	colors_of_walls	,5
PUBDEF	colors_of_panes	,7
PUBDEF	colors_of_bg	,colors_of_rocks+colors_of_walls+colors_of_panes
PUBDEF	top_of_rocks	,1
PUBDEF	num_of_rocks	,28
PUBDEF	top_of_walls	,top_of_rocks+num_of_rocks
PUBDEF	num_of_walls	,67
PUBDEF	top_of_panes	,top_of_walls+num_of_walls
PUBDEF	num_of_panes	,28
tx_bge_lb0:	db	"ROCK0",#FF
tx_bge_lb1:	db	"ROCK1",#FF
tx_bge_lb2:	db	"WALL0",#FF
tx_bge_lb3:	db	"WALL1",#FF
tx_bge_lb4:	db	"WALL2",#FF
tx_bge_lb5:	db	"WALL3",#FF
tx_bge_lb6:	db	"WALL4",#FF
tx_bge_lb7:	db	"PANE0",#FF
tx_bge_lb8:	db	"PANE1",#FF
tx_bge_lb9:	db	"PANE2",#FF
tx_bge_lbA:	db	"PANE3",#FF
tx_bge_lbB:	db	"PANE4",#FF
tx_bge_lbC:	db	"PANE5",#FF
tx_bge_lbD:	db	"PANE6",#FF

tx_tape_r:	db	"@@LOAD@FROM@TAPE@@",#FF
tx_tape_w:	db	"@@SAVE@TO@TAPE@@",#FF
tx_tape_eo:	db	"@@OPEN@ERROR@@",#FF
tx_tape_ew:	db	"@@WRITE@ERROR@@",#FF
tx_tape_er:	db	"@@READ@ERROR@@",#FF
